;ͻ
;           Bill World           
;              v0.1              
;Ķ
; Chewbone Software's first game 
;                                
;ͼ


;RAM:
; $0000 - $00FF = variables
; $0100 - $01FF = stack
; $0200 - $02FF = sprites (for DMA)
; $0300 - $07FF = unused

;variable locations
playerx = $00
playery = $01
playeranim = $02
playerframe = $03
framedelay = $04
joypad1 = $05
joypad2 = $06
joypad3 = $07
joypad4 = $08
pointlo = $09
pointhi = $0A
playeranim2 = $0B
yv = $0C
temp = $0D
temp2 = $0E
temp3 = $0F
tx = $10
ty = $11
joypad1p = $12
joypad2p = $13
joypad3p = $14
joypad4p = $15
push = $16
scrollx = $17
scrolly = $18
PPU1 = $19
PPU2 = $20
paused = $21

.org $8000
	sei		;disable interrupts
	cld		;clear decimal mode
	ldx #$FF	;set stack pointer to $FF
	txs
vblank1	lda $2002	;wait for vblank twice (the PPU has to warm up)
	bpl vblank1
vblank2	lda $2002
	bpl vblank2

	lda #$00	;disable screen so VRAM is always accessible
	sta $2000
	sta PPU1
	sta $2001
	sta PPU2

	lda #$3F	;set VRAM address to $3F00 (palette RAM)
	sta $2006
	lda #$00
	sta $2006
	inx		;load & store $20 values
palloop	lda palettes,X
	sta $2007
	inx
	cpx #$20
	bne palloop

	lda #$20
	sta $2006
	lda #$00
	sta $2006
	jsr drawscreen
	jsr drawattr
	lda #$24
	sta $2006
	lda #$00
	sta $2006
	jsr drawscreen
	jsr drawattr

	lda #$00
	sta $2006
	sta $2006
	sta playery
	sta playerframe
	sta framedelay
	sta yv
	sta scrollx
	sta scrolly
	lda #$01
	sta playeranim
	lda #$08
	sta playerx

	lda #%10001000	;enable screen
	sta $2000
	sta PPU1
	lda #%00011000
	sta $2001
	sta PPU2

	lda #$07
	sta $4015	;enable Sqare wave 1&2 + Triangle wave

mainloop		;loop forever
	lda #$00	;clear sprite RAM area
	tax
sprloop	sta $200,X
	inx
	bne sprloop
	jsr readjoypad	;read the joypads
	lda paused
	cmp #$02
	beq pause1
	cmp #$01
	beq pause2
	jmp nopause
pause1	lda joypad1
	and #$10
	bne nopause
	dec paused
pause2	lda joypad1
	and #$10
	beq nopause
	dec paused
	lda PPU2
	and #$1F
	sta $2001
	sta PPU2
	lda joypad1p	;disable this start press
	ora #$10
	sta joypad1p
nopause
vblank3	lda $2002
	bpl vblank3
	jmp mainloop

readjoypad		;read the joypads
	lda joypad1	;store previous values
	sta joypad1p
	lda joypad2
	sta joypad2p
	lda joypad3
	sta joypad3p
	lda joypad4
	sta joypad4p
	ldx #$01	;strobe joypads 1 & 3
	stx $4016
	dex
	sta $4016
	ldx #$08
joy1loop
	lda $4016	;load $4016 and roll D0 into joypad1
	ror A
	rol joypad1
	dex
	bne joy1loop
	ldx #$08
joy3loop
	lda $4016	;load $4016 and roll D0 into joypad3
	ror A
	rol joypad3
	dex
	bne joy3loop
	ldx #$08

	ldx #$01	;strobe joypads 2 & 4
	stx $4017
	dex
	sta $4017
	ldx #$08
joy2loop
	lda $4017	;load $4017 and roll D0 into joypad2
	ror A
	rol joypad2
	dex
	bne joy2loop
	ldx #$08
joy4loop
	lda $4017	;load $4017 and roll D0 into joypad4
	ror A
	rol joypad4
	dex
	bne joy4loop
	ldx #$08
	rts

drawscreen
;	lda #$20	;set VRAM address to $2000 (Name Table 0)
;	sta $2006
;	lda #$00
;	sta $2006
	sta tx		;set (tx,ty) to (0,0)
	sta ty
blockloopy
	lda #$00
	sta tx
blockloopx
	lda tx		;calculate the offset into the level data
	lsr A
	sta temp
	lda ty
	lsr A
	asl A
	asl A
	asl A
	asl A
	ora temp
	sta temp
	ldx temp
	lda L0,X	;get the block byte
	sta temp
	lda #$00	;calculate the offset into the pointer table
	sta temp2
	lda ty
	lsr A
	rol temp2
	lda tx
	lsr A
	rol temp2
	lda temp2
	asl A
	tax
	lda Pt,X	;get the address of the correct table
	sta pointlo
	inx
	lda Pt,X
	sta pointhi
	ldy temp
	lda (pointlo),Y	;get the tile value from the table

	sta $2007

	inc tx		;loop blockloopx
	lda tx
	cmp #$20
	bne blockloopx
	inc ty		;loop blockloopy
	lda ty
	cmp #$1E
	bne blockloopy
	rts

drawattr
;	lda #$23	;set VRAM address to $23C0 (Attribute Table 0)
;	sta $2006
;	lda #$C0
;	sta $2006
	lda #$00
	sta tx		;set (tx,ty) to (0,0)
	sta ty
attrloopy
	lda #$00
	sta tx
attrloopx
	lda tx		;calculate the offset into the level data
	asl A
	sta temp
	lda ty
	asl A
	asl A
	asl A
	asl A
	asl A
	ora temp
	sta temp

	ldx temp
	lda L0,X	;get block byte 0
	sta temp2
	ldx temp2
	lda At,X
	and #$03
	sta temp3


	ldx temp
	inx
	lda L0,X	;get block byte 1
	sta temp2
	ldx temp2
	lda At,X
	and #$0C
	ora temp3
	sta temp3

	lda temp
	clc
	adc #$10
	sta temp
	ldx temp
	lda L0,X	;get block byte 2
	sta temp2
	ldx temp2
	lda At,X
	and #$30
	ora temp3
	sta temp3

	ldx temp
	inx
	lda L0,X	;get block byte 3
	sta temp2
	ldx temp2
	lda At,X
	and #$C0
	ora temp3
	sta temp3

	lda temp3
	sta $2007

	inc tx		;loop blockloopx
	lda tx
	cmp #$08
	bne attrloopx
	inc ty		;loop blockloopy
	lda ty
	cmp #$08
	bne attrloopy
	rts

chardata
.db $0D,$0C,$0F,$0E	;standingl
.db $0C,$0D,$0E,$0F	;standingr
.db $0D,$0C,$19,$18	;walking0l
.db $0D,$0C,$1B,$1A	;walking1l
.db $0D,$0C,$1D,$1C	;walking2l
.db $0D,$0C,$1F,$1E	;walking3l
.db $0D,$0C,$21,$20	;walking4l
.db $0D,$0C,$23,$22	;walking5l
.db $0D,$0C,$25,$24	;walking6l
.db $0D,$0C,$27,$26	;walking7l
.db $0D,$0C,$29,$28	;walking8l
.db $0D,$0C,$2B,$2A	;walking9l
.db $0D,$0C,$2D,$2C	;walkingAl
.db $0D,$0C,$2F,$2E	;walkingBl
.db $0D,$0C,$11,$10	;walkingCl
.db $0D,$0C,$13,$12	;walkingDl
.db $0D,$0C,$15,$14	;walkingEl
.db $0D,$0C,$17,$16	;walkingFl
.db $0C,$0D,$18,$19	;walking0r
.db $0C,$0D,$1A,$1B	;walking1r
.db $0C,$0D,$1C,$1D	;walking2r
.db $0C,$0D,$1E,$1F	;walking3r
.db $0C,$0D,$20,$21	;walking4r
.db $0C,$0D,$22,$23	;walking5r
.db $0C,$0D,$24,$25	;walking6r
.db $0C,$0D,$26,$27	;walking7r
.db $0C,$0D,$28,$29	;walking8r
.db $0C,$0D,$2A,$2B	;walking9r
.db $0C,$0D,$2C,$2D	;walkingAr
.db $0C,$0D,$2E,$2F	;walkingBr
.db $0C,$0D,$10,$11	;walkingCr
.db $0C,$0D,$12,$13	;walkingDr
.db $0C,$0D,$14,$15	;walkingEr
.db $0C,$0D,$16,$17	;walkingFr
.db $05,$04,$07,$06	; jumpingl
.db $04,$05,$06,$07	; jumpingr
.db $09,$08,$0B,$0A	; fallingl
.db $08,$09,$0A,$0B	; fallingr

footdata
.db $39,$38		;standingl
.db $38,$39		;standingr
.db $31,$30		;walking0/8l
.db $33,$32		;walking1/9l
.db $35,$34		;walking2/Al
.db $37,$36		;walking3/Bl
.db $39,$38		;walking4/Cl
.db $3B,$3A		;walking5/Dl
.db $3D,$3C		;walking6/El
.db $3F,$3E		;walking7/Fl
.db $30,$31		;walking0/8r
.db $32,$33		;walking1/9r
.db $34,$35		;walking2/Ar
.db $36,$37		;walking3/Br
.db $38,$39		;walking4/Cr
.db $3A,$3B		;walking5/Dr
.db $3C,$3D		;walking6/Er
.db $3E,$3F		;walking7/Fr
.db $00,$01		;jumpingl
.db $01,$00		;jumpingr
.db $03,$02		;fallingl
.db $02,$03		;fallingr

palettes
.db $0D,$06,$16,$26	;bricks
.db $0D,$04,$14,$24	;blocks
.db $0D,$21,$31,$30	;sky
.db $0D,$07,$2A,$21	;ground
.db $0D,$0D,$16,$30	;red
.db $0D,$0D,$17,$30	;orange
.db $0D,$0D,$1A,$30	;green
.db $0D,$0D,$11,$30	;blue

Pt
.dw T0,T1,T2,T3

T0
.db $01,$04,$08,$0E,$03,$03,$10,$14,$14,$12,$15,$15,$16,$14
T1
.db $01,$05,$09,$03,$0F,$03,$14,$11,$14,$15,$13,$15,$14,$17
T2
.db $01,$06,$0A,$01,$0F,$03,$12,$15,$15,$12,$15,$15,$12,$15
T3
.db $01,$07,$0B,$0E,$01,$03,$15,$13,$15,$15,$13,$15,$15,$13
At
.db $AA,$00,$55,$AA,$AA,$AA,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
Co
.db $00,$01,$01,$00,$00,$00,$01,$01,$01,$01,$01,$01,$01,$01
Br
.db $00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
Ne
.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00

L0
.db $05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05
.db $05,$05,$05,$05,$04,$03,$05,$05,$05,$05,$05,$05,$04,$03,$05,$05
.db $05,$05,$05,$04,$00,$00,$03,$05,$05,$05,$05,$04,$00,$00,$03,$05
.db $05,$05,$04,$00,$00,$00,$00,$03,$05,$05,$04,$00,$00,$00,$00,$03
.db $03,$04,$00,$00,$00,$00,$00,$00,$03,$04,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$02,$00,$00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
.db $00,$02,$00,$00,$01,$02,$01,$02,$01,$00,$06,$07,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$09,$0A,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$09,$0A,$00,$00,$00,$00
.db $08,$08,$08,$08,$08,$08,$08,$08,$08,$08,$0D,$0C,$07,$00,$00,$06
.db $0B,$0B,$0B,$0B,$0B,$0B,$0B,$0B,$0B,$0B,$0A,$09,$0A,$00,$00,$09
.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00

sound
.db $84,$8F,$00,$09	;jump
.db $84,$87,$00,$8C	;hit head

hitdown
	ldx #$00
	lda playery
	clc
	adc #$10
	and #$F0
	sta temp
	lda playerx
	clc
	adc #$03
	and #$F0
	lsr A
	lsr A
	lsr A
	lsr A
	ora temp
	sta temp
	ldx temp
	lda L0,X
	tax
	lda Co,X
	bne hitdownhit

	lda temp
	and #$F0
	sta temp
	lda playerx
	clc
	adc #$0C
	and #$F0
	lsr A
	lsr A
	lsr A
	lsr A
	ora temp
	sta temp
	ldx temp
	lda L0,X
	tax
	lda Co,X
	bne hitdownhit
	jmp hitdownnot
hitdownhit
	ldx #$01
	rts
hitdownnot
	ldx #$00
	rts


hitup
	ldx #$00
	lda playery
	clc
	adc #$02
	and #$F0
	sta temp
	lda playerx
	clc
	adc #$03
	and #$F0
	lsr A
	lsr A
	lsr A
	lsr A
	ora temp
	sta temp
	ldx temp
	lda L0,X
	tax
	lda Co,X
	bne hituphit

	lda temp
	and #$F0
	sta temp
	lda playerx
	clc
	adc #$0C
	and #$F0
	lsr A
	lsr A
	lsr A
	lsr A
	ora temp
	sta temp
	ldx temp
	lda L0,X
	tax
	lda Co,X
	bne hituphit
	jmp hitupnot
hituphit
	ldx #$01
	rts
hitupnot
	ldx #$00
	rts


hitright
	ldx #$00
	lda playerx
	clc
	adc #$0E
	and #$F0
	lsr A
	lsr A
	lsr A
	lsr A
	sta temp
	lda playery
	clc
	adc #$02
	and #$F0
	ora temp
	sta temp
	ldx temp
	lda L0,X
	tax
	lda Co,X
	bne hitrighthit

	lda temp
	and #$0F
	sta temp
	lda playery
	clc
	adc #$0F
	and #$F0
	ora temp
	sta temp
	ldx temp
	lda L0,X
	tax
	lda Co,X
	bne hitrighthit
	jmp hitrightnot
hitrighthit
	ldx #$01
	rts
hitrightnot
	ldx #$00
	rts

hitleft
	ldx #$00
	lda playerx
	clc
	adc #$01
	and #$F0
	lsr A
	lsr A
	lsr A
	lsr A
	sta temp
	lda playery
	clc
	adc #$02
	and #$F0
	ora temp
	sta temp
	ldx temp
	lda L0,X
	tax
	lda Co,X
	bne hitlefthit

	lda temp
	and #$0F
	sta temp
	lda playery
	clc
	adc #$0F
	and #$F0
	ora temp
	sta temp
	ldx temp
	lda L0,X
	tax
	lda Co,X
	bne hitlefthit
	jmp hitleftnot
hitlefthit
	ldx #$01
	rts
hitleftnot
	ldx #$00
	rts

nmi	lda paused
	beq notpaused
	rti
notpaused
	lda playeranim
	sta playeranim2
	lda #$00
	sta push

	lda joypad1
	and #$42
	cmp #$02
	bne notleft
	dec playerx		;left - B
;	lda playerx
;	cmp #$06
;	bne leftnowrap
;	lda #$07
;	sta playerx
;	lda #$01
;	sta push
;leftnowrap
	lda #$02
	sta playeranim
notleft	lda joypad1
	and #$41
	cmp #$01
	bne notright
	inc playerx		;right - B
;	lda playerx
;	cmp #$F2
;	bne rightnowrap
;	lda #$F1
;	sta playerx
;	lda #$01
;	sta push
;rightnowrap
	lda #$03
	sta playeranim
notright
	lda joypad1
	and #$42
	cmp #$42
	bne notleftB
	dec playerx		;left + B
;	lda playerx
;	cmp #$06
;	bne leftB1nowrap
;	lda #$07
;	sta playerx
;	lda #$01
;	sta push
;leftB1nowrap
	dec playerx
;	lda playerx
;	cmp #$06
;	bne leftB2nowrap
;	lda #$07
;	sta playerx
;	lda #$01
;	sta push
;leftB2nowrap
	lda #$04
	sta playeranim
	inc playerframe
notleftB
	lda joypad1
	and #$41
	cmp #$41
	bne notrightB
	inc playerx		;right + B
;	lda playerx
;	cmp #$F2
;	bne rightB1nowrap
;	lda #$F1
;	sta playerx
;	lda #$01
;	sta push
;rightB1nowrap
	inc playerx
;	lda playerx
;	cmp #$F2
;	bne rightB2nowrap
;	lda #$F1
;	sta playerx
;	lda #$01
;	sta push
;rightB2nowrap
	lda #$05
	sta playeranim
	inc playerframe
notrightB
	lda joypad1
	and #$03
	bne adirection
	lda playeranim		;neither left nor right
	and #$01
	sta playeranim
adirection
	lda joypad1
	and #$80
	beq notA
	lda joypad1p
	and #$80
	bne notA
	jsr hitdown		;A button
	cpx #$01
	bne notA
	lda #$F1
	sta yv

	ldx #$00
	lda sound,X
	sta $4000
	inx
	lda sound,X
	sta $4001
	inx
	lda sound,X
	sta $4002
	inx
	lda sound,X
	sta $4003
notA	lda joypad1
	and #$10
	beq notstart
	lda joypad1p
	and #$10
	bne notstart		;start button
	lda #$02
	sta paused
	lda PPU2
	ora #$E0
	sta $2001
	sta PPU2
notstart

	lda playeranim
	cmp playeranim2
	beq nothingnew
	lda #$00
	sta playerframe
	sta framedelay
nothingnew

	inc yv
	lda yv
	cmp #$0F
	bne yvok
	lda #$0E
	sta yv
yvok
	lda yv
	and #$C0
	sta temp
	lda yv
	lsr A
	and #$3F
	ora temp
	clc
	adc playery
	sta playery
	lda playery
	and #$F0
	cmp #$F0
	bne novwrap
	lda playery
	clc
	adc #$10
	sta playery
novwrap
	jsr hitdown
	cpx #$01
	bne nothitting
	lda playery
	and #$F0
	sta playery
	jmp hitting
nothitting
	lda yv
	bpl falldown
	lda playeranim
	and #$01
	ora #$06
	sta playeranim
	jmp hitdone
falldown
	lda playeranim
	and #$01
	ora #$08
	sta playeranim
	jmp hitdone
hitting
	lda #$00
	sta yv
hitdone
	jsr hitup
	cpx #$01
	bne hitupdone
	lda playery
	and #$F0
	clc
	adc #$0E
	sta playery
	lda #$00
	sta yv

	ldx #$04
	lda sound,X
	sta $4000
	inx
	lda sound,X
	sta $4001
	inx
	lda sound,X
	sta $4002
	inx
	lda sound,X
	sta $4003
hitupdone
	jsr hitright
	cpx #$01
	bne hitrightdone
	lda playerx
	and #$F0
	clc
	adc #$01
	sta playerx
	lda #$01
	sta push
hitrightdone
	jsr hitleft
	cpx #$01
	bne hitleftdone
	lda playerx
	and #$F0
	clc
	adc #$0F
	sta playerx
	lda #$01
	sta push
hitleftdone

	lda push
	beq notpushing
	jsr hitdown
	cpx #$01
	bne notpushing
	lda playeranim
	and #$01
	sta playeranim
notpushing

	inc framedelay
	lda framedelay
	cmp #$01
	bne frameok
	inc playerframe
	lda #$00
	sta framedelay
frameok
	lda playerframe
	cmp #$10
	bmi frameok2
	lda #$00
	sta playerframe
frameok2

	lda playerx
	clc
	adc #$80
	sta scrollx


	lda playeranim
	cmp #$00
	bne not0
	ldx #$00
	ldy #$43
not0	cmp #$01
	bne not1
	ldx #$04
	ldy #$03
not1	cmp #$02
	bne not2
	pha
	lda playerframe
	clc
	rol A
	clc
	rol A
	clc
	adc #$08
	tax
	pla
	ldy #$43
not2	cmp #$03
	bne not3
	pha
	lda playerframe
	clc
	rol A
	clc
	rol A
	clc
	adc #$48
	tax
	pla
	ldy #$03
not3	cmp #$04
	bne not4
	pha
	lda playerframe
	clc
	rol A
	clc
	rol A
	clc
	adc #$08
	tax
	pla
	ldy #$43
not4	cmp #$05
	bne not5
	pha
	lda playerframe
	clc
	rol A
	clc
	rol A
	clc
	adc #$48
	tax
	pla
	ldy #$03
not5	cmp #$06
	bne not6
	ldx #$88
	ldy #$43
not6	cmp #$07
	bne not7
	ldx #$8C
	ldy #$03
not7	cmp #$08
	bne not8
	ldx #$90
	ldy #$43
not8	cmp #$09
	bne not9
	ldx #$94
	ldy #$03
not9

	lda playery
	sec
	sbc scrolly
	sta $0200
	sta $0204
	clc
	adc #$08
	sta $0208
	sta $020C

	lda playerx
	sec
	sbc scrollx
	sta $0203
	sta $020B
	clc
	adc #$08
	sta $0207
	sta $020F
	sty $0202
	sty $0206
	sty $020A
	sty $020E
	lda chardata,X
	sta $0201
	inx
	lda chardata,X
	sta $0205
	inx
	lda chardata,X
	sta $0209
	inx
	lda chardata,X
	sta $020D


	ldx #$00
	ldy #$00

	lda playeranim
	cmp #$00
	bne not0f
	ldx #$00
	ldy #$40
not0f	cmp #$01
	bne not1f
	ldx #$02
	ldy #$00
not1f	cmp #$02
	bne not2f
	pha
	lda playerframe
	clc
	adc #$04
	asl A
	and #$0E
	clc
	adc #$04
	tax
	pla
	ldy #$40
not2f	cmp #$03
	bne not3f
	pha
	lda playerframe
	clc
	adc #$04
	asl A
	and #$0E
	clc
	adc #$14
	tax
	pla
	ldy #$00
not3f	cmp #$04
	bne not4f
	pha
	lda playerframe
	clc
	adc #$04
	asl A
	and #$0E
	clc
	adc #$04
	tax
	pla
	ldy #$40
not4f	cmp #$05
	bne not5f
	pha
	lda playerframe
	clc
	adc #$04
	asl A
	and #$0E
	clc
	adc #$14
	tax
	pla
	ldy #$00
not5f	cmp #$06
	bne not6f
	ldx #$24
	ldy #$40
not6f	cmp #$07
	bne not7f
	ldx #$26
	ldy #$00
not7f	cmp #$08
	bne not8f
	ldx #$28
	ldy #$40
not8f	cmp #$09
	bne not9f
	ldx #$2A
	ldy #$00
not9f

	lda playery
	sec
	sbc scrolly
	clc
	adc #$08
	sta $0210
	sta $0214
	lda playerx
	sec
	sbc scrollx

	sta $0213
	clc
	adc #$08
	sta $0217
	sty $0212
	sty $0216
	lda footdata,X
	sta $0211
	inx
	lda footdata,X
	sta $0215

	lda #$02	;start sprite DMA
	sta $4014

	lda #$00
	sta $2006
	sta $2006

	lda scrollx
	sta $2005
	lda playery
	clc
	adc #$80
	bvs nooverflow
	clc
	sbc #$10
nooverflow
	lda #$00
	lda scrolly
	sta $2005
	rti

.org $FFF9		;IRQ/BRK routine (nothing)
	rti

.org $FFFA		;vector table (NMI,reset,IRQ/BRK)
.dw nmi,$8000,$FFF9
.end
